LIBRARY ieee;
USE ieee.std_logic_1164.all; 
use ieee.numeric_std.all;
USE ieee.std_logic_arith.ALL;
USE ieee.std_logic_unsigned.ALL;
LIBRARY work;
-- 	приводится кодирование параметра mode 
--		он задает формат представления исходных операндов
--		0   Прямой код, целые числа.
--		1   Прямой код, дробные числа.
--		2   Обратный код, целые числа.
--		3   Обратный код, дробные числа.
--		4   Дополнительный код, целые числа.
--		5   Дополнительный код, дробные числа.

ENTITY rconv IS 
GENERIC (n : INTEGER:=4; mode : integer:=5);
	PORT
	(
		x :  in  STD_LOGIC_VECTOR(2*n-1 DOWNTO 0);				-- первый операнд (множимое)
		xpr : buffer  STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END rconv;

ARCHITECTURE prconv OF rconv IS 
BEGIN
	rconvproc:
	process(x)
		variable xbin,xp : std_logic_vector(2*n-1  downto 0);
	-- хр - в прямом коде
	begin
		xbin:=x;
		if xbin(2*n-1)='1' then 
			if(mode=0 or mode=1) then	-- если отрицательное, то преобразум его в положительное
				xp:='0'& xbin(2*n-2 downto 0);	--  если прямой код
			elsif(mode=2 or mode=3) then xp:=not xbin(2*n-1 downto 0);		--  если обратный код
			elsif(mode=4 or mode=5) then xp:=not xbin(2*n-1 downto 0)+1;		--  если дополнительный код
			end if;
			else xp:=xbin; 
		end if;	-- иначе, не меняем
		xpr(14 downto 2*n-1) <= (others => '0');
		xpr(2*n-2 downto 0) <= xp(2*n-2 downto 0);
		xpr(15) <= xbin(2*n-1);
	end process;
END prconv;